//BEGIN signal.sqf
//By Hailo (totaldamage.org)
//Add to the init of the soldiers to have the smoke signal system : nil = [this] execVM "misc\signal.sqf";

private ["_run","_MaxDistPickup","_MaxDistTarget","_MaxWaitPickup","_MaxWaitTarget","_unit","_killer","_caller","_id","_args","_event","_pos","_marker","_nightTime"];

if (local server and !local player) then {
	_unit = _this select 0; 
	_unit setVehicleInit "nil = [this] execVM ""misc\signal.sqf"";"
};
if (local player) then {
	if(format["%1",SMOKE_Pickup_TimeLastRun] == "scalar bool array string 0xe0ffffef") then {
		SMOKE_Pickup_TimeLastRun = objNull;
	};
	if(format["%1",SMOKE_Target_TimeLastRun] == "scalar bool array string 0xe0ffffef") then {
		SMOKE_Target_TimeLastRun = objNull;
	};
	
	// maximum distance from player (meters)
	_MaxDistPickup = 300;
	_MaxDistTarget = 1500;
	
	// seconds to wait before allowing the action to continue
	_MaxWaitPickup = 60;
	_MaxWaitTarget = 60;
	
	_run = true;
	_unit = objNull;
	_killer = objNull;
	_caller = objNull;
	_id = objNull;
	_args = 0;
	
	_event = objNull;
	_pos = objNull;
	_marker = objNull;
	_nightTime = false;
	
	// 19:30 it starts to get dark. 04:30 it starts the sun comes up.
	if (daytime >= 19.5 or daytime <= 4.5) then { _nightTime = true; };
	
	if (count _this == 3) then {
		_event = _this select 0;
		switch (_event) do {
			case "MapClick": {
				_pos = _this select 1;
				_args = _this select 2;
				_caller = player;
				
				if (_nightTime) then {
					_pos = [_pos select 0, _pos select 1, 255];
				} else {
					_pos = [_pos select 0, _pos select 1, 0];
				};
			};
		case "Killed": {
				_unit = (_this select 1) select 0;
				_killer = (_this select 1) select 1;
				_args = _this select 2;
				_caller = player;
			};
			default { hint "signal.sqf: The requested event is un-suported."; };
		};
	} else {
		if (count _this > 1) then {
			// Action Fired
			_unit = _this select 0;
			_caller = _this select 1;
			_id = _this select 2;
			
			_pos = getPos _caller;
			_pos = [_pos select 0, _pos select 1, 0];
			
			if (count _this > 3) then {
				_args = _this select 3;
			};
		};
	};
	
	//titletext[ "signal.sqf: " + format["_unit = %1, _caller = %2, _id = %3, _args = %4", _unit, _caller, _id, _args], "Plain down"];
	
	switch (_args) do {
		case 0: {
			_unit = _this select 0;
			if (local server and local player) then {
				_unit setVehicleInit "nil = [this] execVM ""misc\signal.sqf"";"
			};
			if(_unit == player) then {
				player removeEventHandler ["killed", 0];
				player addEventHandler ["killed", { nil = ["Killed",_this, 5] execVM "misc\signal.sqf"; }];
				
				if(format["%1",actionIdPickup] != "scalar bool array string 0xe0ffffef") then {
					_unit removeAction actionIdPickup;
				};
				actionIdPickup = _unit addAction["Signal: Pickup","misc\signal.sqf",1,1,false,false,"buldSelect"];
				
				if(format["%1",actionIdTarget] != "scalar bool array string 0xe0ffffef") then {
					_unit removeAction actionIdTarget;
				};
				actionIdTarget = _unit addAction["Signal: Target","misc\signal.sqf",2,1,false,false,"buldSelect"];
			};
		};
		case 1: { // Pickup
			if(format["%1",SMOKE_Pickup_TimeLastRun] != "<NULL-object>") then {
				if((daytime - SMOKE_Pickup_TimeLastRun) <= (0.5/30)) then {
					_run = false;
					hint format["You can try again in %1 seconds", (round ((((0.5/1800)*_MaxWaitPickup) - (daytime - SMOKE_Pickup_TimeLastRun))/(0.5/1800)))];
				};
			};
			if (_run) then {
				hint format["Select a location on the map. \n\nIt must be within %1m from your current position.",_MaxDistPickup];
				
				if(format["getMarkerPos = %1", getMarkerPos "Target"] != "[0,0,0]") then { 
					deleteMarkerLocal "Target"; 
					onMapSingleClick "";
				};
				if(format["getMarkerPos = %1", getMarkerPos "Pickup"] != "[0,0,0]") then { 
					deleteMarkerLocal "Pickup"; 
					onMapSingleClick "";
				};
				
				_marker = "Pickup";
				createMarkerLocal [_marker, _pos];
				_marker setMarkerShapeLocal "ELLIPSE";
				_marker setMarkerSizeLocal [_MaxDistPickup, _MaxDistPickup];
				_marker setMarkerBrushLocal "FDiagonal";
				_marker setMarkerColorLocal "ColorGreenAlpha";
				
				onMapSingleClick "nil = [""MapClick"",_pos, 3] execVM ""misc\signal.sqf"";";
			};
		};
		case 2: { // Target
			if(format["%1",SMOKE_Target_TimeLastRun] != "<NULL-object>") then {
				if((daytime - SMOKE_Target_TimeLastRun) <= (0.5/30)) then {
					_run = false;
					hint format["You can try again in %1 seconds", (round ((((0.5/1800)*_MaxWaitTarget) - (daytime - SMOKE_Target_TimeLastRun))/(0.5/1800)))];
				};
			};
			if (_run) then {
				hint format["Select a location on the map. \n\nIt must be within %1m from your current position.",_MaxDistTarget];
					
				if(format["getMarkerPos = %1", getMarkerPos "Target"] != "[0,0,0]") then { 
					deleteMarkerLocal "Target"; 
					onMapSingleClick "";
				};
				if(format["getMarkerPos = %1", getMarkerPos "Pickup"] != "[0,0,0]") then { 
					deleteMarkerLocal "Pickup"; 
					onMapSingleClick "";
				};
					
				_marker = "Target";
				createMarkerLocal [_marker, _pos];
				_marker setMarkerShapeLocal "ELLIPSE";
				_marker setMarkerSizeLocal [_MaxDistTarget, _MaxDistTarget];
				_marker setMarkerBrushLocal "FDiagonal";
				_marker setMarkerColorLocal "ColorRedAlpha";
				
				onMapSingleClick "nil = [""MapClick"",_pos, 4] execVM ""misc\signal.sqf"";";
			};
		};
		case 3:{ // MapClick Event: Pickup
			SMOKE_Pickup_TimeLastRun = daytime;
			onMapSingleClick "";
			deleteMarkerLocal "Pickup";
			
			if ((_caller distance _pos) <= _MaxDistPickup) then {
				if (_nightTime) then {
					"F_40mm_Green" createVehicle _pos; // Flare
				} else {
					"SmokeShellGreen" createVehicle _pos; // Smoke
				};
				hint "Your pickup has been marked.";
			} else {
				hint "Your pickup is too far away.";
			};			
		};
		case 4:{ // MapClick Event: Target
			SMOKE_Target_TimeLastRun = daytime;
			onMapSingleClick "";
			deleteMarkerLocal "Target";
			
			if ((_caller distance _pos) <= _MaxDistTarget) then {
				if (_nightTime) then {
					"F_40mm_Red" createVehicle _pos; // Flare
				} else {
					"SmokeShellRed" createVehicle _pos; // Smoke
				};
				hint "Your target has been marked.";
			} else {
				hint "Your target is too far away.";
			};
		};
		case 5:{ // Killed Event
			waitUntil {alive player}; //wait for respawn
			player removeEventHandler ["killed", 0];
			nil = [player] execVM "misc\signal.sqf";
		};
		default { hint "signal.sqf: The requested action is un-suported."; };
	};
};